import { world } from "mojang-minecraft"

export class Coordinate {
    constructor(x, y, z)
    {
        this.x = Math.floor(x)
        this.y = Math.floor(y) + 1
        this.z = Math.floor(z)
    }

    turnToString()
    {
        return `${this.x} ${this.y} ${this.z}`
    }

    getDistance(otherCoordinate)
    {
        var dist = Math.sqrt(Math.pow((this.x - otherCoordinate.x), 2) + Math.pow((this.y - otherCoordinate.y), 2) + Math.pow((this.x - otherCoordinate.x), 2))
        return dist
    }
}

export function debugPrint(msg = "Specify a print value")
{
    world.getDimension("overworld").runCommand(`tellraw @a {"rawtext":[{"text":"[§eDEBUG§f] ${msg}"}]}`)
}

export function notify(msg = "Specify a message", type = "msg")
{
    if (type == "msg")
    {
        world.getDimension("overworld").runCommand(`tellraw @a {"rawtext":[{"text":"[§3world§6Fab§f] ${msg}"}]}`)
    }
    else {
        world.getDimension("overworld").runCommand(`tellraw @a {"rawtext":[{"text":"[§cERROR§f] ${msg}"}]}`)
    }
}

export function runCommand(cmd) 
{
    world.getDimension("overworld").runCommand(cmd)
}

export function splitWithBracket(str) {
    var out = str.split(" "), i = 0, begin, end;

    function findNext(chr) {
        while (i < out.length) {
            if (out[i].indexOf(chr) != -1) {
                out[i] = out[i].replace(chr, "");
                return(i);
            }
            i++;
        }
        return(-1);
    }

    do {
        end = -1;
        begin = findNext("[");
        if (begin != -1) {
            end = findNext("]");
            if (end != -1) {
                var tmp = out.splice(begin, end - begin + 1);
                out.splice(begin, 0, tmp.join(" "));
                i = begin + 1;
            }
        }
    } while (end != -1);
    return(out);
}

export class Stack {
    constructor(size)
    {
        this.size = size
        this.stack = []
    }

    add(newValue) 
    {
        var tempArray = this.stack.slice()

        this.stack[0] = newValue
        for (let i = 1; i < this.size; i++)
        {
          this.stack[i] = tempArray[i - 1] 
        }
    }
}
