import * as mc from "mojang-minecraft"
import * as cmd from './custom_commands.js' 
import { Coordinate, debugPrint, notify, runCommand, Stack } from './helpers.js'

var brush = undefined
var pattern = undefined
var selection = undefined
var builder = undefined
const clipboardSize = 16
var clipboard = undefined
var currentClipboard = 0

//---------------------------------------------------------------------------------
// TODO:
// Actually use my GGC library to format my commands better adn clean up
// Add block states with arrays
// Add support for multiblock patters
// Add mirror command
// Improve selection rotation command
//---------------------------------------------------------------------------------

mc.world.events.beforeChat.subscribe((eventData) => {
    if (eventData.message.substr(0, 1) == cmd.cmdPrefix)
    {
        eventData.cancel = true
        matchCommand(cmd.stringToCommand(eventData.message), eventData.sender)
    }
})

mc.world.events.tick.subscribe(() => {
    try {
        runCommand(`testfor @a[tag=autoKillItems]`)
        runCommand(`kill @e[type=minecraft:item]`)
    }
    catch {
        //okay boomer
    }

    try {
        runCommand(`testfor @a[tag=using]`)
        brush.findPlaceLoc()
        //pattern.findPlaceLoc()
        runCommand(`tag @a[tag=using] remove using`)
    }
    catch {
        //yeah nah, the error handeling caused error, not handeling it doesn't cause errors, idk ¯\_(ツ)_/¯
    }
})

mc.world.events.entityCreate.subscribe((eventData) => {
    if (eventData.entity.id == "gg:pos1")
    {
        var pos1 = new Coordinate(eventData.entity.location.x, eventData.entity.location.y - 1, eventData.entity.location.z)
        notify(`Position 1 set to ${pos1.turnToString()}`)

        if (!selection)
        {
            selection = new Selection(pos1)
        }
        else {
            selection.pos1 = pos1
        }

        runCommand(`event entity @e[type=gg:pos1] gg:despawn`)

    }
    else if (eventData.entity.id == "gg:pos2")
    {
        var pos2 = new Coordinate(eventData.entity.location.x, eventData.entity.location.y - 1, eventData.entity.location.z)
        notify(`Position 2 set to ${pos2.turnToString()}`)

        if (!selection)
        {
            selection = new Selection(undefined, pos2)
        }
        else {
            selection.pos2 = pos2
        }

        runCommand(`event entity @e[type=gg:pos2] gg:despawn`)
    }
})

function matchCommand(cmd, sender)
{
    if (cmd[0] == "help" || cmd[0] == "h")
    {
        notify("Here's all of the commands supported at the moment. Feel free to Search for 'Goggled Gecko World Fabricator 2' on §cYouTube§f for a video tutorial.\n\n§9Add a Brush§f: <!brush / !br> <ball / cylinder / cyl / cone / cube> <radius:number> <block_name> <block_variant:number>{optional} [<mask_block>]{optional} \nExample: !br 3 stone or !brush 5 log 2 [stone] \n§9Add a Pattern Brush§f: <!pattern / !pat> <radius:number> <block_name> <block_variant:number>{optional} [<mask_block>]{optional} \nExample: !pat 3 stone 6 [sand]\n§9Change the Size§f: <!size / !s> <size:number> \n§9Change Block used§f: <!block / !b> <block_name> <block_variant:number>{optional} \n§9Change Block Mask§f: <!mask / !m> [<mask_block_name>] \nMultiple masks can be stringed together, like: !m [stone dirt grass] \n§9Change Shape§f: <!shape> <ball / cylinder / cyl / cube / cone> \n§9Generate shapes§f: <!genShape> <ball / cylinder / cyl / cube> [<dimensions:radius and height>]{only 1 value needed when using the ball / cone} <block_name> <block_variant:number>{optional} [<mask_block>]{optional}\n\n§9Selection§f: While holding the Select Tool, punch a block to set pos1 and interact with a block to set pos2 (right click and left click) or use <!pos1> and <!pos2> \n§9Delete an area§f: <!delete / !del> \n§9Fill an area§f: <!fill> <block name> <block variant>{optional} [<mask block name>]{optional} \n§9Copy an area§f: <!copy / !c> \n§9Paste a copied area§f: <!paste / !p> <clipboard_index:number>{optional} \n16 selections can be copied and saved to the clipboard with !copy. To access a specific item use a number to indicate which one to paste, by default it will paste the most recent one. \n§9Rotate an area§f: <!rotate / !r> <90 / 180 / 270> \nThis will rotate the selected area around pos1 \n§9Kill items automatically§f: <!autoKillItems> <true / false> \nAutomatically removes all of the items on the ground. This can help reduce lag when working with gravity blocks like sand")
    }
    else if (cmd[0] == "autoKillItems")
    {
        if (cmd[1] == "true")
        {
            runCommand(`tag @a add autoKillItems`)
        }
        else if (cmd[1] == "false")
        {
            runCommand(`tag @a remove autoKillItems`)
        }
        else {
            notify(`${cmd[1]} is not a valid value. Expected an Boolean (true/false)`, "error")
        }
    }
    else if (cmd[0] == "brush" || cmd[0] == "br")
    {
        var masks = []
        if (cmd.length > 4)
        {
            masks = cmd[5].split(" ")
        }
        else {
            masks.push("minecraft:air")
        }
        
        brush = new Brush(cmd[1], cmd[2], cmd[3], cmd[4], masks)
        notify(`A new ${cmd[3]} brush has been made`)
    }
    else if (cmd[0] == "pattern" || cmd[0] == "pat")
    {
        var masks = []
        if (cmd.length > 3)
        {
            masks = cmd[4].split(" ")
        }
        else {
            masks.push("minecraft:air")
        }
        
        brush = new Pattern(cmd[1], cmd[2], cmd[3], masks)
        notify(`A new ${cmd[2]} pattern has been made`)

    }
    else if (cmd[0] == "mask" || cmd[0] == "m")
    {
        var masks = []
        masks = cmd[1].split(" ")
        
        notify(`Brush's mask changed to [${masks}]`)
        brush.mask = masks
    }
    else if (cmd[0] == "block" || cmd[0] == "b")
    {
        brush.block = cmd[1]
        if (cmd[2] == null)
        {
            brush.blockData = 0
        }
        else {
            brush.blockData = cmd[2]
        }
        notify(`Brush's block changed to ${cmd[1]}`)
    }
    else if (cmd[0] == "size" || cmd[0] == "s")
    {
        brush.size = cmd[1]
        notify(`Brush's size updated to ${cmd[1]}`)
    }
    else if (cmd[0] == "shape")
    {
        if (brush instanceof Brush)
        {
            brush.shape = cmd[1]
            notify(`Brush's type updated to ${cmd[1]}`)
        }
        else {
            notify(`!shape can only be used on a normal Brush, not a Pattern`, "error")
        }
    }    
    else if (cmd[0] == "genShape")
    {   
        var masks = []
        if (cmd.length > 4)
        {
            masks = cmd[5].split(" ")
        }
        else {
            masks.push("minecraft:air")
        }

        var dimensions = cmd[2].split(" ")
        var shape = new Brush(cmd[1], dimensions[0], cmd[3], cmd[4], masks)

        runCommand(`execute @p ~ ~ ~ summon gg:raycast`)
        
        if (cmd[1] == "ball" || cmd[1] == "cone")
        {
            shape.build()
            notify(`${cmd[1]} generated`)
        }
        else if (cmd[1] == "cylinder" || cmd[1] == "cyl" || cmd[1] == "cube")
        {
            shape.build(dimensions[1])
            notify(`${cmd[1]} generated`)
        }
        else {
            notify(`${cmd[1]} is not a valid shape. Do !help or !h for help`, "error")
        }
        
    }
    else if (cmd[0] == "pos1")
    {
        runCommand(`execute @a[name=${sender.name}] ~ ~ ~ summon gg:pos1`)
    }
    else if (cmd[0] == "pos2")
    {
        runCommand(`execute @a[name=${sender.name}] ~ ~ ~ summon gg:pos2`)
    }
    else if (cmd[0] == "delete" || cmd[0] == "del")
    {
        if (!selection || !selection.pos1 || !selection.pos2)
        {
            notify("Set pos1 and pos2 first. Do !help or !h for help", "error")
        }
        else {
            selection.deleteSelection()
        }
    }
    else if (cmd[0] == "fill")
    {
        if (!selection || !selection.pos1 || !selection.pos2)
        {
            notify("Set pos1 and pos2 first. Do !help or !h for help", "error")
        }
        else {
            if (cmd[3] != null) 
            {
                var masks = []
                masks = cmd[3].split(" ")
                selection.fillSelection(cmd[1], cmd[2], masks)
            }
            else if (cmd[2] == 0)
            {
                selection.fillSelection(cmd[1])
            }
            else {
                selection.fillSelection(cmd[1], cmd[2])
            }
        }
    }
    else if (cmd[0] == "copy" || cmd[0] == "c")
    {
        if (!selection || !selection.pos1 || !selection.pos2)
        {
            notify("Set pos1 and pos2 first. Do !help or !h for help", "error")
        }
        else {
            selection.copySelection()
        }
    }
    else if (cmd[0] == "paste" || cmd[0] == "p")
    {
        if (!selection || !selection.pos1 || !selection.pos2)
        {
            notify("Set pos1 and pos2 first. Do !help or !h for help", "error")
        }
        else {
            if (cmd[1] == null)
            {
                selection.pasteSelection(sender.name)
            }
            else {
                selection.pasteSelection(sender.name, cmd[1])
            }
        }
    }
    else if (cmd[0] == "rotate" || cmd[0] == "r")
    {
        if (!selection || !selection.pos1 || !selection.pos2)
        {
            notify("Set pos1 and pos2 first. Do !help or !h for help", "error")
        }
        else {
            if (cmd[1] == null)
            {
                selection.rotateSelection()
            }
            else {
                selection.rotateSelection(cmd[1])
            }
        }
    }
    else if (cmd[0] == "test")
    {
        //test command
        try {
            notify("Oi, this is my testing command, why are you using it! Try something else instead")
        }
        catch (err) {
            debugPrint(err)
        }

    }
    else {
        //runCommand(`tellraw @a {"rawtext":[{"text":"§c[ERROR]§f '${cmd[0]}' is not a command, do !help for a list of commands"}]}`)
        notify(`'${cmd[0]}' is not a command, do !help or !h for a list of commands`, "error")
    }
}


class Brush {
    constructor(shape, size, block, blockData = 0, mask) {
        this.shape = shape
        this.size = size;
        this.block = block;
        this.blockData = blockData;
        this.mask = mask
        this.using = false
        if (this.size > 15)
        {
            notify(`Brush size [${this.size}] is too big. Brush size set to 15`, "error")
            
            this.size = 15
        }
    }


    build(height = 1)
    {
        if (this.shape == "ball")
        {
            this.sphere()
        }
        else if (this.shape == "cylinder" || this.shape == "cyl")
        {
            this.cylinder(height)
        }
        else if (this.shape == "cone")
        {
            this.cone(height)
        }
        else {
            this.cube(height)
        }

        runCommand(`event entity @e[type=gg:raycast] gg:despawn`)

    }

    sphere()
    {
        for (let i = 0; i < this.mask.length; i++) {
            try {
                var rad = parseInt(this.size) + 1
                for(let tx = -rad; tx < rad + 1; tx++){
                    for(let ty = -rad; ty < rad + 1; ty++){
                        for(let tz = -rad; tz < rad + 1; tz++){
                            if(Math.sqrt(Math.pow(tx, 2) + Math.pow(ty, 2) + Math.pow(tz, 2)) + 0.2 <= rad)
                            {
                                try {
                                    runCommand(`execute @e[type=gg:raycast] ~ ~ ~ fill ~${tx} ~${ty} ~${tz} ~${tx} ~${ty} ~${tz} ${this.block} ${this.blockData} replace ${this.mask[i]}`)
                                }
                                catch {
                                    continue
                                }
                            }
                        }
                    }
                }
            }
            catch {
                continue
            }
        }
    }

    cylinder(height)
    {
        for (let i = 0; i < this.mask.length; i++) {
            try {
                var rad = parseInt(this.size) + 1
                for(let tx = -rad; tx < rad + 1; tx++){
                    for(let tz = -rad; tz < rad + 1; tz++){
                        if(Math.sqrt(Math.pow(tx, 2) + Math.pow(tz, 2)) + 0.2 <= rad)
                        {
                            try {
                                runCommand(`execute @e[type=gg:raycast] ~ ~ ~ fill ~${tx} ~ ~${tz} ~${tx} ~${height - 1} ~${tz} ${this.block} ${this.blockData} replace ${this.mask[i]}`)
                            }
                            catch {
                                continue
                            }
                        }
                    }
                }
            }
            catch {
                continue
            }
        }
    }

    cone()
    {
        for (let i = 0; i < this.mask.length; i++) {
            for (let j = 0; j < (parseInt(this.size) + 1) * 2; j++)
            {
                var height = j
                if (height % 2 != 0)
                {
                    height++
                }
                try {
                    var rad = parseInt(this.size) + 1 - (height / 2)
                    for(let tx = -rad; tx < rad + 1; tx++){
                        for(let tz = -rad; tz < rad + 1; tz++){
                            if(Math.sqrt(Math.pow(tx, 2) + Math.pow(tz, 2)) + 0.2 <= rad)
                            {
                                try {
                                    runCommand(`execute @e[type=gg:raycast] ~ ~ ~ fill ~${tx} ~${height} ~${tz} ~${tx} ~${height + 1} ~${tz} ${this.block} ${this.blockData} replace ${this.mask[i]}`)
                                }
                                catch {
                                    continue
                                }
                            }
                        }
                    }
                }
                catch {
                    continue
                }
            }
        }
    }

    cube(height)
    {
        for (let i = 0; i < this.mask.length; i++) {
            try {
                runCommand(`execute @e[type=gg:raycast] ~ ~ ~ fill ~-${this.size} ~ ~-${this.size} ~${this.size} ~${height - 1} ~${this.size} ${this.block} ${this.blockData} replace ${this.mask[i]}`)
            }
            catch {
                continue
            }
        }
    }

    findPlaceLoc(maxRange = 20)
    {
        try {
            runCommand(`execute @p ^ ^ ^2 summon gg:raycast`)
            runCommand(`execute @e[type=gg:raycast] ~ ~ ~ tp @s ~ ~ ~ facing @p`)

            for (var i = 0; i < maxRange; i++) { 
                runCommand(`function raycast`)
            }
            
            //runCommand(`execute @e[type=gg:raycast] ~ ~ ~ setblock ~ ~ ~ minecraft:diamond_block`)
            this.build()
        }
        catch {
            runCommand(`event entity @e[type=gg:raycast] gg:despawn`)
        }
    }
}

class Pattern {
    constructor(size, block, blockData = 0, mask) {
        this.size = size;
        this.block = block;
        this.blockData = blockData;
        this.mask = mask
        this.using = false

        if (this.size > 15)
        {
            notify(`Brush size [${this.size}] is too big. Brush size set to 15`, "error")
            
            this.size = 15
        }
    }

    build()
    {
        for (let i = 0; i < this.mask.length; i++) {
            try {
                try {
                    for (let j = 0; j < this.size * 5; j++)
                    {
                        var offset = new Coordinate(Math.floor((Math.random() - 0.5) * 2 * this.size),
                                                    Math.floor((Math.random() - 0.5) * 2 * this.size),
                                                    Math.floor((Math.random() - 0.5) * 2 * this.size))
                        runCommand(`execute @e[type=gg:raycast] ^ ^ ^-${this.size} fill ~${offset.x} ~${offset.y} ~${offset.z} ~${offset.x} ~${offset.y} ~${offset.z} ${this.block} ${this.blockData} replace ${this.mask[i]}`)
                    }
                }
                catch {
                    continue
                }
            }
            catch {
                continue
            }
        }

        runCommand(`event entity @e[type=gg:raycast] gg:despawn`)

    }

    findPlaceLoc(maxRange = 20)
    {
        try {
            runCommand(`execute @p ^ ^ ^2 summon gg:raycast`)
            runCommand(`execute @e[type=gg:raycast] ~ ~ ~ tp @s ~ ~ ~ facing @p`)

            for (var i = 0; i < maxRange; i++) { 
                runCommand(`function raycast`)
            }
            
            //runCommand(`execute @e[type=gg:raycast] ~ ~ ~ setblock ~ ~ ~ minecraft:diamond_block`)
            this.build()
        }
        catch {
            runCommand(`event entity @e[type=gg:raycast] gg:despawn`)
        }
    }
}

class Selection {
    constructor(pos1 = undefined, pos2 = undefined)
    {
        this.pos1 = pos1
        this.pos2 = pos2

        this.createClipboard()
    }

    deleteSelection()
    {
        try {
            runCommand(`fill ${this.pos1.turnToString()} ${this.pos2.turnToString()} minecraft:air`)
        }
        catch {
            notify("Selection too big or out of range", "error")
        }
    }

    fillSelection(block, variant = 0, mask = undefined)
    {
        try {
            if (mask == undefined)
            {
                runCommand(`fill ${this.pos1.turnToString()} ${this.pos2.turnToString()} ${block} ${variant}`)
            }
            else {
                for (let i = 0; i < mask.length; i++) {
                    try {
                        runCommand(`fill ${this.pos1.turnToString()} ${this.pos2.turnToString()} ${block} ${variant} replace ${mask[i]}`)
                    }
                    catch {
                        continue
                    }
                }
            }

            
            //runCommand(`fill ${this.pos1.turnToString()} ${this.pos2.turnToString()} ${block} ${variant}`)
        }
        catch (err) {
            notify("Selection too big, out of range or block type does not exist", "error")
        }
    }

    copySelection()
    {
        try {
            currentClipboard++
            var name = `item_${currentClipboard}`
            clipboard.add(name)
            runCommand(`structure save ${name} ${this.pos1.turnToString()} ${this.pos2.turnToString()} false memory`)
        }
        catch {
            notify("Selection too big or out of range", "error")
        }
    }

    pasteSelection(sender, index = 0)
    {
        var name = `item_${currentClipboard - index}`
        runCommand(`execute @a[name=${sender}] ~ ~ ~ structure load ${name} ~ ~ ~`)
        //structure load name 1 1 1 180_degrees xz
    }

    rotateSelection(rotation)
    {
        if (rotation == "90" || rotation == "180" || rotation == "270")
        {
            var tempStructure = "temp"
            runCommand(`structure save ${tempStructure} ${this.pos1.turnToString()} ${this.pos2.turnToString()} false memory`)
            runCommand(`fill ${this.pos1.turnToString()} ${this.pos2.turnToString()} minecraft:air`)
            runCommand(`structure load ${tempStructure} ${this.pos1.turnToString()} ${rotation}_degrees`)
        }
        else {
            notify(`${rotation} is not a valid rotation. Do !help or !h for help`, "error")
        }
    }

    mirrorSelection()
    {
        
    }

    createClipboard()
    {
        clipboard = new Stack(clipboardSize)
    }
}

/*var targetBlock = mc.Player.getBlockFromViewVector()
var hitLocation = targetBlock.location

hitLocation.x*/
